Eclipse BIRT Report Object Model (ROM)

ExtendedItem Element

# Element Overview

Represents an extended item, provide BIRT extenion capability.

### Details

Display Name: | Extended item
Since: | 1.0
XML Element: | `extended-item`
Extends: | ReportItem
Extendable: | Yes
Abstract: | No
Name Space: | Report Items
Name Requirement: | Optional
Allows User Properties: | Yes
Has Style: | Yes
Default Style: | None

### Property Summary

altText
altTextID
extensionName
  A unique extension name to identify the extension
extensionVersion
filter
  A list of filter conditions that can be applied to the extended item

### Method Summary

onCreate
  Script executed when the element is created in the Factory.
onPageBreak
onPrepare
  It is for a script startup phase. No data binding yet. The design of an element can be changed here.
onRender
  Script executed when the element is prepared for rendering in the Presentation engine.

### Inherited Properties

ACLExpression, allowExport, bookmark, bookmarkDisplayName, boundDataColumns, cascadeACL, comments, cube, customXml, dataBindingRef, dataSet, displayName, displayNameID, eventHandlerClass, extends, height, multiViews, name, newHandlerOnEachEvent, paramBindings, propertyMasks, pushDown, refTemplateParameter, style, toc, userProperties, viewAction, visibility, width, x, y, zIndex

### Style Properties

backgroundAttachment, backgroundColor, backgroundImage, backgroundPositionX, backgroundPositionY, backgroundRepeat, backgroundSizeHeight, backgroundSizeWidth, bidiTextDirection, borderBottomColor, borderBottomStyle, borderBottomWidth, borderLeftColor, borderLeftStyle, borderLeftWidth, borderRightColor, borderRightStyle, borderRightWidth, borderTopColor, borderTopStyle, borderTopWidth, canShrink, color, dateFormat, dateTimeFormat, display, fontFamily, fontSize, fontStyle, fontVariant, fontWeight, highlightRules, letterSpacing, lineHeight, mapRules, marginBottom, marginLeft, marginRight, marginTop, masterPage, numberAlign, numberFormat, orphans, paddingBottom, paddingLeft, paddingRight, paddingTop, pageBreakAfter, pageBreakBefore, pageBreakInside, showIfBlank, stringFormat, textAlign, textIndent, textLineThrough, textOverline, textTransform, textUnderline, timeFormat, verticalAlign, whiteSpace, widows, wordSpacing

### Description

Represents an extended item element. The extended report item allows third-party developers to create report items that work within BIRT virtually identically to BIRT-defined items.

Extended items can use the user-properties discussed above to define properties. Extended items are defined in a Java plug-in that contributes behavior to the Eclipse Report Developer, to the Factory and to the Presentation Engine.

The extended item can fully participate with the other BIRT extension facilities, meaning that report developers can add properties and scripts to an extended item, providing a very powerful way to create application-specific functionality. An extended item is defined by a plug-in. The plug-in is specific to BIRT, and is different from an Eclipse plug-in. Each item plug-in has four parts:

- Design: handles the model that describes the report item.
- User Interface: the UI displayed for the item. This is in the form of an Eclipse plug-in.
- Factory: how to gather the data for the extended item, and compute its default size in the Factory.
- Presentation: how to render the extended item when rendering the report to HTML, PDF or other formats.

# Property Detail

## altText Property

### Details

Type: | string
Since: | 2.1
Required: | No
Display Name: | Alternative text
JavaScript Type: |
Default Value: | None
Inherited: | Yes
Runtime Settable: | No
Property Sheet Visibility: | Visible
Property Sheet Group: | Top

## altTextID Property

### Details

Type: | resourceKey
Since: | 2.1
Required: | No
Display Name: | Alternative text key
JavaScript Type: |
Default Value: | None
Inherited: | Yes
Runtime Settable: | Yes
Property Sheet Visibility: | Visible
Property Sheet Group: | Top

## extensionName Property

A unique extension name to identify the extension

### Details

Type: | string
Since: | 1.0
Required: | No
Display Name: | Extension name
JavaScript Type: |
Default Value: | None
Inherited: | Yes
Runtime Settable: | Yes
Property Sheet Visibility: | Hidden
Property Sheet Group: | Top

### Description

Indicates which extension this extended item is extended from.

Using this name, BIRT can get the extension definition. The name is an internal name for an implementation of extension.

## extensionVersion Property

### Details

Type: | string
Since: | 2.2
Required: | No
Display Name: | Extension version
JavaScript Type: |
Default Value: | None
Inherited: | Yes
Runtime Settable: | Yes
Property Sheet Visibility: | Hidden
Property Sheet Group: | Top

## filter Property

A list of filter conditions that can be applied to the extended item

### Details

Type: | List of FilterCondition Structures
Since: | 2.0
Required: | No
Display Name: | Filter
JavaScript Type: |
Default Value: | None
Inherited: | Yes
Runtime Settable: | No
Property Sheet Visibility: | Hidden
Property Sheet Group: | Top

### Description

A list of filter conditions that can be applied to the extended item

# Method Detail

## onCreate Method

Script executed when the element is created in the Factory.

### Synopsis

`None obj.onCreate( )`

### Details

Since: | 1.0
Context: | factory
Arguments: | None
Return Type: | None

### Description

Executed when the element is created in the Factory. Called after the item is created, but before the item is saved to the report document file. See the scripting spec for additional information about this script. Applications should perform visual customization in the on-render script instead.

## onPageBreak Method

### Synopsis

`None obj.onPageBreak( )`

### Details

Since: | 2.1
Context: | presentation
Arguments: | None
Return Type: | None

## onPrepare Method

It is for a script startup phase. No data binding yet. The design of an element can be changed here.

### Synopsis

`None obj.onPrepare( )`

### Details

Since: | 2.0
Context: | startup
Arguments: | None
Return Type: | None

### Description

It is for a script startup phase. No data binding yet. The design of an element can be changed here.

## onRender Method

Script executed when the element is prepared for rendering in the Presentation engine.

### Synopsis

`None obj.onRender( )`

### Details

Since: | 1.0
Context: | presentation
Arguments: | None
Return Type: | None

### Description

Executed when the element is prepared for rendering in the Presentation engine. Changes made to the element are written to the target output format, but not saved to the report document file. This is the preferred place for visual customizations.